package scheme.absyn;

import scheme.interp.*;

public class ConsE extends ExpList {
    private Exp hd;
    private ExpList tl;
    
    ConsE (Exp hd, ExpList tl) {
        this.hd = hd;
        this.tl = tl;
    }

    public void accept (ExpListVisitor v) throws VisitE {
        v.visitConsE(this);
    }

    public Exp hd () { return hd; }

    public ExpList tl () { return tl; }

    public ExpList snoc (Exp last) {
        return new ConsE(hd, tl.snoc(last));
    }
}
