package scheme.interp;

import scheme.absyn.BoolC;
import scheme.absyn.IntC;

public class Eval_Constant implements ConstantVisitor {
    private SchemeValue v;

    public SchemeValue getValue () { return v; }

    public void visitBoolC (BoolC c) throws VisitE {
        v = new BoolV(c.get());
    }

    public void visitIntC (IntC c) throws VisitE {
        v = new IntV(c.get());
    }
}
