// $ANTLR 2.7.1: "scheme.g" -> "SchemeParser.java"$

package scheme.parser;
import scheme.absyn.*;
import scheme.util.*;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

public class SchemeParser extends antlr.LLkParser
       implements SchemeTokenTypes
 {

protected SchemeParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public SchemeParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected SchemeParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public SchemeParser(TokenStream lexer) {
  this(lexer,2);
}

public SchemeParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final void exp() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST exp_AST = null;
		Token  plp = null;
		AST plp_AST = null;
		Token  alp = null;
		AST alp_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case EOF:
			{
				AST tmp1_AST = null;
				tmp1_AST = (AST)astFactory.create(LT(1));
				match(Token.EOF_TYPE);
				exp_AST = (AST)currentAST.root;
				break;
			}
			case TRUE:
			{
				AST tmp2_AST = null;
				tmp2_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp2_AST);
				match(TRUE);
				exp_AST = (AST)currentAST.root;
				break;
			}
			case FALSE:
			{
				AST tmp3_AST = null;
				tmp3_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp3_AST);
				match(FALSE);
				exp_AST = (AST)currentAST.root;
				break;
			}
			case INT:
			{
				AST tmp4_AST = null;
				tmp4_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp4_AST);
				match(INT);
				exp_AST = (AST)currentAST.root;
				break;
			}
			case ID:
			{
				AST tmp5_AST = null;
				tmp5_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp5_AST);
				match(ID);
				exp_AST = (AST)currentAST.root;
				break;
			}
			case QUOTECHAR:
			{
				AST tmp6_AST = null;
				tmp6_AST = (AST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp6_AST);
				match(QUOTECHAR);
				datum();
				astFactory.addASTChild(currentAST, returnAST);
				exp_AST = (AST)currentAST.root;
				break;
			}
			default:
				if ((LA(1)==LPAREN) && (LA(2)==LITERAL_quote)) {
					AST tmp7_AST = null;
					tmp7_AST = (AST)astFactory.create(LT(1));
					match(LPAREN);
					AST tmp8_AST = null;
					tmp8_AST = (AST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp8_AST);
					match(LITERAL_quote);
					datum();
					astFactory.addASTChild(currentAST, returnAST);
					AST tmp9_AST = null;
					tmp9_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					exp_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==LPAREN) && (LA(2)==26)) {
					AST tmp10_AST = null;
					tmp10_AST = (AST)astFactory.create(LT(1));
					match(LPAREN);
					AST tmp11_AST = null;
					tmp11_AST = (AST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp11_AST);
					match(26);
					AST tmp12_AST = null;
					tmp12_AST = (AST)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp12_AST);
					match(ID);
					exp();
					astFactory.addASTChild(currentAST, returnAST);
					AST tmp13_AST = null;
					tmp13_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					exp_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==LPAREN) && (LA(2)==LITERAL_if)) {
					AST tmp14_AST = null;
					tmp14_AST = (AST)astFactory.create(LT(1));
					match(LPAREN);
					AST tmp15_AST = null;
					tmp15_AST = (AST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp15_AST);
					match(LITERAL_if);
					exp();
					astFactory.addASTChild(currentAST, returnAST);
					exp();
					astFactory.addASTChild(currentAST, returnAST);
					exp();
					astFactory.addASTChild(currentAST, returnAST);
					AST tmp16_AST = null;
					tmp16_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					exp_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==LPAREN) && (LA(2)==LITERAL_begin)) {
					AST tmp17_AST = null;
					tmp17_AST = (AST)astFactory.create(LT(1));
					match(LPAREN);
					AST tmp18_AST = null;
					tmp18_AST = (AST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp18_AST);
					match(LITERAL_begin);
					{
					_loop31:
					do {
						if ((_tokenSet_0.member(LA(1)))) {
							exp();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							break _loop31;
						}
						
					} while (true);
					}
					AST tmp19_AST = null;
					tmp19_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					exp_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==LPAREN) && (LA(2)==LITERAL_let)) {
					AST tmp20_AST = null;
					tmp20_AST = (AST)astFactory.create(LT(1));
					match(LPAREN);
					AST tmp21_AST = null;
					tmp21_AST = (AST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp21_AST);
					match(LITERAL_let);
					AST tmp22_AST = null;
					tmp22_AST = (AST)astFactory.create(LT(1));
					match(LPAREN);
					{
					_loop33:
					do {
						if ((LA(1)==LPAREN)) {
							decl();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							break _loop33;
						}
						
					} while (true);
					}
					AST tmp23_AST = null;
					tmp23_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					exp();
					astFactory.addASTChild(currentAST, returnAST);
					AST tmp24_AST = null;
					tmp24_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					exp_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==LPAREN) && (LA(2)==LITERAL_letrec)) {
					AST tmp25_AST = null;
					tmp25_AST = (AST)astFactory.create(LT(1));
					match(LPAREN);
					AST tmp26_AST = null;
					tmp26_AST = (AST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp26_AST);
					match(LITERAL_letrec);
					AST tmp27_AST = null;
					tmp27_AST = (AST)astFactory.create(LT(1));
					match(LPAREN);
					{
					_loop35:
					do {
						if ((LA(1)==LPAREN)) {
							decl();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							break _loop35;
						}
						
					} while (true);
					}
					AST tmp28_AST = null;
					tmp28_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					exp();
					astFactory.addASTChild(currentAST, returnAST);
					AST tmp29_AST = null;
					tmp29_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					exp_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==LPAREN) && (LA(2)==LITERAL_lambda)) {
					AST tmp30_AST = null;
					tmp30_AST = (AST)astFactory.create(LT(1));
					match(LPAREN);
					AST tmp31_AST = null;
					tmp31_AST = (AST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp31_AST);
					match(LITERAL_lambda);
					params();
					astFactory.addASTChild(currentAST, returnAST);
					exp();
					astFactory.addASTChild(currentAST, returnAST);
					AST tmp32_AST = null;
					tmp32_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					exp_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==LPAREN) && (_tokenSet_1.member(LA(2)))) {
					plp = LT(1);
					plp_AST = (AST)astFactory.create(plp);
					astFactory.makeASTRoot(currentAST, plp_AST);
					match(LPAREN);
					prim();
					astFactory.addASTChild(currentAST, returnAST);
					{
					_loop37:
					do {
						if ((_tokenSet_0.member(LA(1)))) {
							exp();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							break _loop37;
						}
						
					} while (true);
					}
					AST tmp33_AST = null;
					tmp33_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					plp_AST.setType(PRIM);
					exp_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==LPAREN) && (_tokenSet_0.member(LA(2)))) {
					alp = LT(1);
					alp_AST = (AST)astFactory.create(alp);
					astFactory.makeASTRoot(currentAST, alp_AST);
					match(LPAREN);
					exp();
					astFactory.addASTChild(currentAST, returnAST);
					{
					_loop39:
					do {
						if ((_tokenSet_0.member(LA(1)))) {
							exp();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							break _loop39;
						}
						
					} while (true);
					}
					AST tmp34_AST = null;
					tmp34_AST = (AST)astFactory.create(LT(1));
					match(RPAREN);
					alp_AST.setType(APP);
					exp_AST = (AST)currentAST.root;
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
		returnAST = exp_AST;
	}
	
	public final void datum() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST datum_AST = null;
		Token  lp = null;
		AST lp_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case TRUE:
			{
				AST tmp35_AST = null;
				tmp35_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp35_AST);
				match(TRUE);
				datum_AST = (AST)currentAST.root;
				break;
			}
			case FALSE:
			{
				AST tmp36_AST = null;
				tmp36_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp36_AST);
				match(FALSE);
				datum_AST = (AST)currentAST.root;
				break;
			}
			case INT:
			{
				AST tmp37_AST = null;
				tmp37_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp37_AST);
				match(INT);
				datum_AST = (AST)currentAST.root;
				break;
			}
			case LPAREN:
			{
				lp = LT(1);
				lp_AST = (AST)astFactory.create(lp);
				astFactory.makeASTRoot(currentAST, lp_AST);
				match(LPAREN);
				AST tmp38_AST = null;
				tmp38_AST = (AST)astFactory.create(LT(1));
				match(RPAREN);
				lp_AST.setType(EMPTY_LIST);
				datum_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
		returnAST = datum_AST;
	}
	
	public final void decl() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST decl_AST = null;
		Token  lp = null;
		AST lp_AST = null;
		
		try {      // for error handling
			lp = LT(1);
			lp_AST = (AST)astFactory.create(lp);
			astFactory.makeASTRoot(currentAST, lp_AST);
			match(LPAREN);
			AST tmp39_AST = null;
			tmp39_AST = (AST)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp39_AST);
			match(ID);
			exp();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp40_AST = null;
			tmp40_AST = (AST)astFactory.create(LT(1));
			match(RPAREN);
			lp_AST.setType(DECL);
			decl_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_3);
		}
		returnAST = decl_AST;
	}
	
	public final void params() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST params_AST = null;
		Token  lp = null;
		AST lp_AST = null;
		
		try {      // for error handling
			lp = LT(1);
			lp_AST = (AST)astFactory.create(lp);
			astFactory.makeASTRoot(currentAST, lp_AST);
			match(LPAREN);
			{
			_loop42:
			do {
				if ((LA(1)==ID)) {
					AST tmp41_AST = null;
					tmp41_AST = (AST)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp41_AST);
					match(ID);
				}
				else {
					break _loop42;
				}
				
			} while (true);
			}
			AST tmp42_AST = null;
			tmp42_AST = (AST)astFactory.create(LT(1));
			match(RPAREN);
			lp_AST.setType(PARAMS);
			params_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
		returnAST = params_AST;
	}
	
	public final void prim() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST prim_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case MINUS:
			{
				AST tmp43_AST = null;
				tmp43_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp43_AST);
				match(MINUS);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case TIMES:
			{
				AST tmp44_AST = null;
				tmp44_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp44_AST);
				match(TIMES);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case PLUS:
			{
				AST tmp45_AST = null;
				tmp45_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp45_AST);
				match(PLUS);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case LESS:
			{
				AST tmp46_AST = null;
				tmp46_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp46_AST);
				match(LESS);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case LEQ:
			{
				AST tmp47_AST = null;
				tmp47_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp47_AST);
				match(LEQ);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case EQ:
			{
				AST tmp48_AST = null;
				tmp48_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp48_AST);
				match(EQ);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 32:
			{
				AST tmp49_AST = null;
				tmp49_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp49_AST);
				match(32);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 33:
			{
				AST tmp50_AST = null;
				tmp50_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp50_AST);
				match(33);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_car:
			{
				AST tmp51_AST = null;
				tmp51_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp51_AST);
				match(LITERAL_car);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_cdr:
			{
				AST tmp52_AST = null;
				tmp52_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp52_AST);
				match(LITERAL_cdr);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_cons:
			{
				AST tmp53_AST = null;
				tmp53_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp53_AST);
				match(LITERAL_cons);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 37:
			{
				AST tmp54_AST = null;
				tmp54_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp54_AST);
				match(37);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_not:
			{
				AST tmp55_AST = null;
				tmp55_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp55_AST);
				match(LITERAL_not);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 39:
			{
				AST tmp56_AST = null;
				tmp56_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp56_AST);
				match(39);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 40:
			{
				AST tmp57_AST = null;
				tmp57_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp57_AST);
				match(40);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 41:
			{
				AST tmp58_AST = null;
				tmp58_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp58_AST);
				match(41);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 42:
			{
				AST tmp59_AST = null;
				tmp59_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp59_AST);
				match(42);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_void:
			{
				AST tmp60_AST = null;
				tmp60_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp60_AST);
				match(LITERAL_void);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 44:
			{
				AST tmp61_AST = null;
				tmp61_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp61_AST);
				match(44);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 45:
			{
				AST tmp62_AST = null;
				tmp62_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp62_AST);
				match(45);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 46:
			{
				AST tmp63_AST = null;
				tmp63_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp63_AST);
				match(46);
				prim_AST = (AST)currentAST.root;
				break;
			}
			case 47:
			{
				AST tmp64_AST = null;
				tmp64_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp64_AST);
				match(47);
				prim_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
		returnAST = prim_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"TRUE",
		"FALSE",
		"LEQ",
		"QUOTECHAR",
		"LPAREN",
		"RPAREN",
		"MINUS",
		"DOT",
		"TIMES",
		"PLUS",
		"LESS",
		"EQ",
		"ID",
		"INT",
		"WS",
		"COMMENT",
		"APP",
		"PRIM",
		"EMPTY_LIST",
		"DECL",
		"PARAMS",
		"\"quote\"",
		"\"set!\"",
		"\"if\"",
		"\"begin\"",
		"\"let\"",
		"\"letrec\"",
		"\"lambda\"",
		"\"add1\"",
		"\"boolean?\"",
		"\"car\"",
		"\"cdr\"",
		"\"cons\"",
		"\"integer?\"",
		"\"not\"",
		"\"null?\"",
		"\"pair?\"",
		"\"procedure?\"",
		"\"sub1\"",
		"\"void\"",
		"\"zero?\"",
		"\"eq?\"",
		"\"set-car!\"",
		"\"set-cdr!\""
	};
	
	private static final long _tokenSet_0_data_[] = { 197042L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long _tokenSet_1_data_[] = { 281470681805888L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	private static final long _tokenSet_2_data_[] = { 197554L, 0L };
	public static final BitSet _tokenSet_2 = new BitSet(_tokenSet_2_data_);
	private static final long _tokenSet_3_data_[] = { 768L, 0L };
	public static final BitSet _tokenSet_3 = new BitSet(_tokenSet_3_data_);
	
	}
