package scheme.absyn;

import scheme.util.List;

public class LambdaE extends Exp {
    private List ids;
    private Exp body;

    public LambdaE (List ids, Exp body) {
        this.ids = ids;
        this.body = body;
    }

    public List getIds () { return ids; }

    public Exp getBody () { return body; }

    public void accept (scheme.interp.ExpVisitor v) throws scheme.interp.VisitE {
        v.visitLambdaE(this);
    }
}
