package scheme.absyn;

import scheme.util.List;

public class LetE extends Exp {
    private List decls;
    private Exp body;

    public LetE (List decls, Exp body) {
        this.decls = decls;
        this.body = body;
    }

    public List getDecls () { return decls; }

    public Exp getBody () { return body; }

    public void accept (scheme.interp.ExpVisitor v) throws scheme.interp.VisitE {
        v.visitLetE(this);
    }
}

